package com.cert.Chapter_2;

public class Constructor {
	int x, y;

	// A default constructor looks like this
	// public Constructor(){}
	private Constructor() {

	}

	// A constructor w/ arguments
	public Constructor(int x, int y) {
		this.x = x;
		this.y = y;
	}

	// WARNING - This is not a constructor
	public void Constructor() {
	}
}

final class SuperConstructorExample extends Constructor {
	//
	public SuperConstructorExample(int x, int y) {
		super(x, y);
	}
	// public SuperConstructorExample() { }
}

final class OverloadingConstructorExample {
	String name;

	public OverloadingConstructorExample(String name) {
		this.name = name;
	}

	public OverloadingConstructorExample() {
		this(makeRandomName());
	}

	static String makeRandomName() {
		int x = (int) (Math.random() * 5);
		String name = new String[] { "Fluffy", "Fido", "Rover", "Spike", "Gigi" }[x];
		return name;
	}

	public static void main(String[] args) {
		OverloadingConstructorExample ex1 = new OverloadingConstructorExample();
		System.out.println(ex1.name);

		OverloadingConstructorExample ex2 = new OverloadingConstructorExample("Zeus");
		System.out.println(ex2.name);
	}
}