package com.cert.Chapter_2;

public class LegalReturnTypes {
	void go(){ 	}
	
	LegalReturnTypes doStuff(){
		return new LegalReturnTypes();
	}
}
final class ShowcaseClassOne extends LegalReturnTypes {
	//String go(){ }
	//the return type doesn't have to match that of the superclass version
	String go(int x){ return null; }
}

final class ShowcaseClassTwo extends LegalReturnTypes {
	//What's new in 1.5!!
	ShowcaseClassTwo doStuff(){
		return new ShowcaseClassTwo();
	}
	
	//Rule 1 - You can return null in a method with an object reference return type.
	public String returnNull(){
		return null;
	}
	
	//Rule 2 - An array is a perfectly legal return type.
	public String[] returnStrArray() {
		return new String[] {"Fred", "Barney", "Wilma"};
	}
	
	//Rule 3 - If it fits, it ships
	public int foo() {
		char c = 'c';
		return c; // char is compatible with int
	}
	
	//Rule 4 - If it fits (after casting), it ships
	public int foo2 () {
		float f = 32.5f;
		return (int) f;
	}
	
	//Rule 5 - You must not return anything from a method with a void return type.
	public void foo3(){
			//return "this is it"; // Not legal!!
	}
	
	//Rule 6 - In a method with an object reference return type, you can return any 
	//object type that can be implicitly cast to the declared return type.
	public Object foo4(){
		int[] nums = {1,2,3};
		return nums; // Return an int array,
		// which is still an object
	}
}