package com.cert.Chapter_8;

//Inner classes
// regular
//  	 Method-local inner classes
//  	 Anonymous inner classes
//  	 Static nested classes
/*
 so the following modifiers can be applied to an inner class:  final
 abstract
 public
 private
 protected
 static—but static turns it into a static nested class not an inner class
 strictfp
 */
public class InnerClasses {
	private int i = 0;
	private static int j = 1;

	public static void main(String args[]) {
		System.out.println("InnerClasses main");
		// Inner i = new Inner();
		InnerClasses outerClass = new InnerClasses();
		InnerClasses.Inner innerClass = outerClass.new Inner();

	}

	public InnerClasses() {
		System.out.println("InnerClasses Constructor");
		Inner inner = new Inner();
		Inner2 inner2 = new Inner2();
		// don't need to intantiate inner class
		inner2.i3.innerMethod();
		// can't do this, not a static
		// InnerClasses.Inner2.i3.innerMethod();
		// InnerClasses.Inner2.i3.innerMethod();
		doStuff();
	}

	interface Cookable {
		public void cook();
	}

	class Food {
		Cookable c = new Cookable() {			
			public void cook() {
				System.out.println("anonymous cookable implementer");
			}
		};
	}

	class Inner2 {
		// The Popcorn reference variable refers not to an instance of Popcorn,
		// but to an
		// instance of an anonymous (unnamed) subclass of Popcorn.
		// Anonymous Inner Classes,
		public Inner i3 = new Inner() {
			public void innerMethod() {
				System.out.println("innerMethod from Inner2");
			}

			public void iM2() {
			}
		};

		public Inner2() {
			i3.innerMethod();
		}
	}

	class Inner {
		// InnerClasses parentThis = InnerClasses.this;
		private int i = 100;

		public Inner() {
			System.out.println("Inner Constructor");
			System.out.println(this.i);
			System.out.println(InnerClasses.this.i);
			System.out.println(InnerClasses.j);
		}

		public void innerMethod() {
			System.out.println("Inner.InnerMethod");
		}
	}

	private String x = "Outer2";

	void doStuff() {
		final String a = "final";
		String b = "private";
		// String c = "static";
		class MyInner {
			public void seeOuter() {
				System.out.println("Outer x is " + x);
				System.out.println("Outer x is " + a);
				// System.out.println("Outer x is " + b);
			} // close inner class method
		} // close inner class definition
		MyInner mi = new MyInner();
		mi.seeOuter();
	} // close outer class method doStuff()

}
